from scipy.fftpack import fft
import numpy as np
from matplotlib import pyplot as plt

tstep = 0.01
n = 1000
l = 5
x = np.array([np.exp((0+1j)*l*k/n*2*np.pi) for k in range(n)])*0 + 0.7*np.array([np.exp((0-1j)*7.2*k/n*2*np.pi) for k in range(n)])

trange = np.array([k*tstep for k in range(n)])
frange = np.linspace(-np.pi/tstep, np.pi*(n-2)/n/tstep, n)#np.array([2*np.pi/tstep*k/n for k in range(n)])
y1 = fft(x)

# fig, ax = plt.subplots()
# ax.plot(trange, x.imag)
# ax.plot(trange, x.real)
# ax.legend(["Imag","Real"])
y = np.fft.fftshift(y1)
fig2, ax2 = plt.subplots()
component = np.absolute(y)
ax2.plot(frange, y.real)
ax2.plot(frange, y.imag)
ax2.legend(["Real", "Imag"])
maxloc = np.argmax(component)
maxfreq = frange[maxloc]
title_str = "$\omega=%f$" % maxfreq
plt.title(title_str)
plt.show()
