import tkinter as tk
import history_tk
import snap_read_tk
import equilibrium_tk
import grids_eq_tk
from tkinter.filedialog import askdirectory

window = tk.Tk()
global_win_grp = []
global_btn_grp = []
window.title('GTC-X VIS')
# window.geometry('200x600')
work_dir = None
def create_panel(create_func):
    for p in global_win_grp:
        if p.read:
            p.destroy()
    global_win_grp.clear()
    create_func(window, global_win_grp,work_dir)

def open_folder():
    global work_dir
    if work_dir:
        return
    for p in global_win_grp:
        if p.read:
            p.destroy()
    global_win_grp.clear()
    work_dir = askdirectory()
    if not work_dir:
        return
    for btn in global_btn_grp:
        btn.config(state="normal")
    global_btn_grp[0].config(state="disable")

def close_folder():
    global work_dir
    if not work_dir:
        return
    for p in global_win_grp:
        if p.read:
            p.destroy()
    global_win_grp.clear()
    work_dir = None
    for btn in global_btn_grp:
        btn.config(state="disable")
    global_btn_grp[0].config(state="normal")

uni_font = ("Helvetica", 20)
btn_open = tk.Button(master=window, text="Open Folder", command=open_folder, font=uni_font)
btn_open.grid(row=1,column=1,sticky=tk.W+tk.E, padx=20)
global_btn_grp.append(btn_open)

btn_hist = tk.Button(master=window, text="History", command=lambda: create_panel(history_tk.panel), state="disable", font=uni_font)
global_btn_grp.append(btn_hist)
btn_hist.grid(row=2,column=1,sticky=tk.W+tk.E, padx=20)

btn_snap = tk.Button(master=window, text="Snapshot", command=lambda: create_panel(snap_read_tk.panel), state="disable", font=uni_font)
global_btn_grp.append(btn_snap)
btn_snap.grid(row=3,column=1,sticky=tk.W+tk.E, padx=20)

btn_fluid = tk.Button(master=window, text="Fluid", command=lambda: create_panel(snap_read_tk.fluid_panel), state="disable", font=uni_font)
global_btn_grp.append(btn_fluid)
btn_fluid.grid(row=4,column=1,sticky=tk.W+tk.E, padx=20)

btn_eq = tk.Button(master=window, text="Equilibrium", command=lambda: create_panel(equilibrium_tk.panel), state="disable", font=uni_font)
global_btn_grp.append(btn_eq)
btn_eq.grid(row=5,column=1,sticky=tk.W+tk.E, padx=20)

btn_geq = tk.Button(master=window, text="Grids eq", command=lambda: create_panel(grids_eq_tk.panel), state="disable", font=uni_font)
global_btn_grp.append(btn_geq)
btn_geq.grid(row=6,column=1,sticky=tk.W+tk.E, padx=20)

btn_close = tk.Button(master=window, text="Close Folder", command=close_folder, state="disable", font=uni_font)
global_btn_grp.append(btn_close)
btn_close.grid(row=7,column=1,sticky=tk.W+tk.E, padx=20)

if __name__ == "__main__":
    window.mainloop()